/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	labels "k8s.io/apimachinery/pkg/labels"
	listers "k8s.io/client-go/listers"
	cache "k8s.io/client-go/tools/cache"
	wardlev1alpha1 "k8s.io/sample-apiserver/pkg/apis/wardle/v1alpha1"
)

// FlunderLister helps list Flunders.
// All objects returned here must be treated as read-only.
type FlunderLister interface {
	// List lists all Flunders in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*wardlev1alpha1.Flunder, err error)
	// Flunders returns an object that can list and get Flunders.
	Flunders(namespace string) FlunderNamespaceLister
	FlunderListerExpansion
}

// flunderLister implements the FlunderLister interface.
type flunderLister struct {
	listers.ResourceIndexer[*wardlev1alpha1.Flunder]
}

// NewFlunderLister returns a new FlunderLister.
func NewFlunderLister(indexer cache.Indexer) FlunderLister {
	return &flunderLister{listers.New[*wardlev1alpha1.Flunder](indexer, wardlev1alpha1.Resource("flunder"))}
}

// Flunders returns an object that can list and get Flunders.
func (s *flunderLister) Flunders(namespace string) FlunderNamespaceLister {
	return flunderNamespaceLister{listers.NewNamespaced[*wardlev1alpha1.Flunder](s.ResourceIndexer, namespace)}
}

// FlunderNamespaceLister helps list and get Flunders.
// All objects returned here must be treated as read-only.
type FlunderNamespaceLister interface {
	// List lists all Flunders in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*wardlev1alpha1.Flunder, err error)
	// Get retrieves the Flunder from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*wardlev1alpha1.Flunder, error)
	FlunderNamespaceListerExpansion
}

// flunderNamespaceLister implements the FlunderNamespaceLister
// interface.
type flunderNamespaceLister struct {
	listers.ResourceIndexer[*wardlev1alpha1.Flunder]
}
